<?php
/*
Plugin Name: CSV to HTML Premium
Plugin URI: http://www.wibergsweb.se/plugins/csvtohtml
Description: CSV to html extension for simplyifing a lot!
Version: 0.96
Author: Wibergs Web
Author URI: http://www.wibergsweb.se/
Text Domain: csvtohtml-wp
Domain Path: /lang
License: GPLv2
*/
defined( 'ABSPATH' ) or die( 'No access allowed!' );

if( !class_exists('csvtohtmlwpPremium') ) {

    //Main class
    class csvtohtmlwpPremium
    {
        private $shortcode;

    /**
    *  Constructor
    *
    *  This function will construct all the neccessary actions, filters and functions 
    *  after all plugins has loaded (because we need CSV to html plugin active)
    *
    *  @param	N/A
    *  @return	N/A
    */	
    public function __construct() 
    {                 
        add_action( 'plugins_loaded', array( $this, 'loadlanguage' ) );
    }
    

    public function csvtohtml_css() {

    }


    /**
     * loadjs
     * 
     * This function load javascript and (if there are any) translations
     *  
     *  @param	N/A
     *  @return	N/A
     *                 
     */    
    public function loadlanguage() 
    {             
        //Load (if there are any) translations
        $loaded_translation = load_plugin_textdomain( 'csvtohtml-wp', false, dirname( plugin_basename(__FILE__) ) . '/lang/' );
        add_action( 'init', array( $this, 'init' ) );        
   }      

    /**
     *  init
     * 
     *  This function initiates the actual shortcodes etc
     * 
     *  @param N/A
     *  @return N/A
     *                 
     */        
    public function init() 
    {        
        wp_register_style( 'csvtohtml-css-premium', plugins_url('/css/wibergsweb.css', __FILE__), false );
        wp_enqueue_style( 'csvtohtml-css-premium' );

        wp_enqueue_script( 'jquery' );    
        wp_enqueue_script(
            'csvtohtml-js-premium',
            plugins_url( '/js/wibergsweb.js' , __FILE__, array('jquery') )
        );     

        add_action('wp_ajax_getdefaults', array($this,'get_defaults_json'));
        add_action('wp_ajax_getform', array($this,'formvalues_shortcode'));

        wp_localize_script( 'csvtohtml-js-premium', 'my_ajax_object', array( 
            'ajax_url' => admin_url( 'admin-ajax.php' )
        ));
             
        add_action( 'add_meta_boxes', array($this, 'metabox_csvtohtml_settings' ));
        add_action( 'admin_menu', array( $this, 'help_page') );
        
    }

    public function metabox_csvtohtml_settings() {

        add_meta_box(
            'csvtohtml-settings',
            __( 'Settings CSV to HTML', 'csvtohtml-wp' ),
            array($this, 'settings_csvtohtml'),
            null, 'normal', 'high',
            array(
                '__block_editor_compatible_meta_box' => true,
            )
        );


    }

		
    public function help_page() 
    {       
        add_menu_page( 'CSV to HTML Premium', 'CSV to html Premium', 'manage_options', 'csv-to-html-premium-info', array( $this, 'startpage') );                                 
    }
    

    /**
     * get_defaults_json
     * 
     * @param void
     * @return $json    json-format     json-format for key/pair
     */
    public function get_defaults_json() {
        $csvtohtml_base = new csvtohtmlwp();
        $defaults = $csvtohtml_base->get_defaults();        
        echo json_encode( $defaults );
        wp_die();
    }


    /**
     *  settings_csvtohtml()
     * 
     *  This function shows settings based on attributes in a shortcode 
     *  for CSV to html
     * 
     *  @param $post        post object     Current post
     *  @param $metabox    
     * 
     *  @return void
     *                 
     */    
    public function settings_csvtohtml( $post, $metabox ) 
    {           
        if (!class_exists('csvtohtmlwp')) {
            echo 'CSV to HTML (free version) must be installed for this plugin to work.';
            wp_die();
        }

        //Create new instance of CSV to HTML
        $csvtohtml_base = new csvtohtmlwp();
        $defaults = $csvtohtml_base->get_defaults();
        
        //Get current post's content (which is shortcode)
        $current_post = get_post( $post->ID );
        $current_content = $current_post->post_content;
            
        //Get all shortcodes (that is csvtohtml) and put them in an array 
        //(If there are only one shortcode found, then just have an array with one item)
        $needle = "[csvtohtml_create";
        $start_pos_sc = 0;               
        $found_shortcode = []; 
        $positions = [];   
        while ( ( $start_pos_sc = stripos($current_content, $needle, $start_pos_sc ) )!== false ) 
        {                                   
            //$start_pos_sc is startposition of a shortcode, find last position of this specific shortcode
            //and add it to array $found_shortcode
            if ( stripos ( $current_content, ']', $start_pos_sc ) !== false ) 
            {
                $end_sc = stripos ( $current_content, ']', $start_pos_sc );
                $found_shortcode[] = mb_substr($current_content, intval($start_pos_sc), intval($end_sc) - intval($start_pos_sc) + 1 );                 
            }            

            $start_pos_sc = $start_pos_sc + mb_strlen($needle) + 1;
        }

        //If no shortcode exists on page, then use default fetch from alla csv-files
        //in users upload-folder
        if ( count( $found_shortcode) == 0 ) 
        {
            $found_shortcode[] = '[csvtohtml_create source_files="*.csv" source_type="guess"]';           
        }
        

        $current_shortcodeindex = 0;
        if (get_transient('scindex'))
        {
            $current_shortcodeindex = get_transient('scindex');
        }

        if ( !isset( $found_shortcode[$current_shortcodeindex] ) )
        {
            $current_shortcodeindex = 0;
        }

        $dat = json_encode( $found_shortcode[$current_shortcodeindex] ); //[0] is first item in list. If session changed, use that shortcode!
        $shortcode = json_decode( $dat, true );

        $html = '<div class="wrap admin">';              
        $html .= '<span id="shortcode">'. $shortcode . '</span>';
        $html .= '<table>';    
        $html .= '<tr><td><span style="font-weight:800;">Shortcode:</span></td><td><select name="frm_current_shortcode" class="choice_sc">';
        $html_input = '';



        $html_input .= '<span style="display:none;" id="current_shortcodeid">' . $current_shortcodeindex . '</span>'; //Zero is important to set first shortcode as active!!!
        foreach( $found_shortcode as $key=>$sc) {
            $args = preg_split('/"[^"]+"(*SKIP)(*F)|\h+/', $sc);
       
            $attrs = [];
            foreach( $args as $item )
            {
                //Only use those items in array $args with = sign
                if ( strpos( $item , '=' ) !== false )
                {
                    $sep = explode( '=', $item );
                    $key2 = $sep[0];
                    $value = $sep[1];
                    $attrs[$key2] = str_replace( '"', '', $value );
                }
            }
            $sc_attributes = wp_parse_args( $attrs, $defaults );
            $sc_attributes['debug_mode'] = 'no'; //This is not needed now when checking directly from settings page

            $identifier_user_shortcode = '';
            if ( mb_strlen( $sc_attributes['path']) > 0 ) {                
                $identifier_user_shortcode .= $sc_attributes['path'] . '/';
            }
            else 
            {
                if (!stristr($sc_attributes['source_files'],'http')) 
                {
                    $identifier_user_shortcode .= 'uploads/';
                }
            }
            $identifier_user_shortcode .=  $sc_attributes['source_files'];
            $selected_index = '';
            if ( $key == $current_shortcodeindex ) {
                $selected_index = ' selected';
            }
            $html .= '<option' . $selected_index . ' value="' . $key . '">' . $identifier_user_shortcode . '</option>';

            $html_input .= '<span style="display:none;" id="scodes' . $key . '">' . $sc . '</span>';
        }
        $html .='</select>';
        $html .= $html_input;
        
        $html .= '</td></tr>';

        $html .= '<tr><td><!--New shortcode:--></td><td>';
        $html .= '<span id="new_shortcode" style="display:none;font-weight:bold;">' . $shortcode . '</span></td></tr>';
        $html .= '</table>';
        $html .= '</div>';

        $html .= '<div id="dynamic_form">';
        echo $html;
        echo $this->formvalues_shortcode( $found_shortcode, $shortcode, $defaults );
        echo '</div>'; //end dynamic form
        
        
    }


    /**
     * create_select_encoding()
     * 
     * helpfunction for creating select element with supported encodings
     * 
     * @param $select_name    name of the select-element
     * @param $name           name of the value to compare with (so set selected or not)
     * @return $html
     * 
     */
    private function create_select_encoding( $select_name, $name ) {
        $list_encodings = mb_list_encodings();
        $list_encodings[] = 'Windows-1255'; //Special because this is not included as standard in supported encodings
        sort($list_encodings);

        //Include these two at beginning of array
        unset( $list_encodings['auto'] );
        unset( $list_encodings['pass'] );        
        array_unshift($list_encodings, "", "auto", "pass"); //Prepend to array
        $list_encodings = array_unique( $list_encodings );

        $html = '<select name="' . $select_name . '">';            
        foreach ( $list_encodings as $encoding )
        {
            $selected_encoding = '';
            if ( $name == $encoding ) 
            {
                $selected_encoding = ' selected';
            }
            $html .= '<option' . $selected_encoding . ' value="' . $encoding . '">' . $encoding . '</option>';
        }
        $html .= '</select>';
        return $html;
    }


    /**
     * formvalues_shortcode()
     * 
     * helpfunction for creating form based on shortcode attributes
     * 
     * @param $shortcode    string
     * @return $html        string
     * 
     */
    public function formvalues_shortcode( $found_shortcode = null, $shortcode = null, $defaults = array() ) 
    {         
        $html = ''; 
       if (isset($_GET['shortcode'])) { 
            $shortcode = stripslashes( $_GET['shortcode']); 
            set_transient( 'scindex', $_GET['current_scid'], 3600 );
        }

        /** 
         * Explode by spaces but not when spaces are within quotes (when having filename that has spaces)
         * @source https://stackoverflow.com/questions/66163283/how-to-explode-a-string-but-not-within-quotes-in-php/66163363?noredirect=1#66163363
        */
        $args = preg_split('/"[^"]+"(*SKIP)(*F)|\h+/', $shortcode);
       
        $attrs = [];
        foreach( $args as $item )
        {
            //Only use those items in array $args with = sign
            if ( strpos( $item , '=' ) !== false )
            {
                $sep = explode( '=', $item );
                $key = $sep[0];
                $value = $sep[1];
                $attrs[$key] = str_replace( '"', '', $value );
            }
        }

        $sc_attributes = wp_parse_args( $attrs, $defaults );
        $sc_attributes['debug_mode'] = 'no';
        $shortcode = str_replace('debug_mode', 'skipdebug_mode', $shortcode); //Ignore debugmode. This is not needed now when checking directly from settings page

        extract( $sc_attributes );

        //Base upload-dir
        $upload_dir = wp_upload_dir();
        $upload_basedir = $upload_dir['basedir'];


        $table_data = do_shortcode( $shortcode );
        
        
        //Copy attributes to another array and add return_rows_array to get
        //total number of columns and rows in file(s) fetched
        $csvtohtml_base = new csvtohtmlwp();
        $temp_attribs = array_slice( $sc_attributes , 0);
        $temp_attribs['return_rows_array'] = 'yes';

        //remove inclusion/exclusion to make sure all cols/rows are included
        if ( isset ( $temp_attribs['include_cols']) ) 
        {
            $temp_attribs['include_cols'] = null;
        }
        if ( isset ( $temp_attribs['exclude_cols']) ) 
        {
            $temp_attribs['exclude_cols'] = null;
        }        

        $rows_arr =  $csvtohtml_base->source_to_table( $temp_attribs );
        if ( isset( $rows_arr[0])) 
        {
            $nr_cols = count( $rows_arr[0] );
        }
        else 
        {
            $nr_cols = 0;
        }

        if ( isset( $rows_arr) )
        {
            $nr_rows = count ( $rows_arr );        
        }
        else 
        {
            $nr_rows = 0;
        }
        
       

        
        //Debugging section
        //
        $debug_info = [];
        if ( $nr_cols == 0 || $nr_rows == 0) {
            $debug_info[] = '<b>No data found in file(s).</b><br>Probably you\'re pointing to incorrect source/file.<br>If it is an external file, make sure you could access the file directly.';
        }

        $ex = explode(';', $source_files);
        $incorrect_csv = [];
        foreach($ex as $item) 
        {
            if (substr($item,-4,4) === '.csv') 
            {
            }
            else 
            {
                $incorrect_csv[] = $item;
            }
        }


        $first = true;
        foreach( $incorrect_csv as $csvitem) {
            
            //.csv not end of string. found .csv and end it after that                
            $s = stripos( $csvitem, '.csv');               
            if ( $s >0 ) {
                if ( $s != mb_strlen($csvitem)-4 ) {
                    if ( $first === true )
                    {
                        $debug_info[] = '<span style="display:block;font-weight:bold;padding:0;margin:0;">File(s) below seems to be incorrect</span>';
                        $first = false;
                    }                  
                    $new_csvitem = substr($csvitem, 0, $s) . '.csv';
                    if ( $csvitem == '.csv') {$new_csvitem = '*.csv';}                    
                    $debug_info[] = '<div class="adjustspelling-wrapper"> Did you mean <b><span data-file="' . $csvitem . '" class="adjustspelling">' . $new_csvitem . '</span>? <button class="changefile">Click here to change spelling. The page will update after this change so make sure you have changed all settings before trying this.</button></div>';               
                }
            }
            else {
                //.csv not found at all
                if ( $first === true )
                {
                    $debug_info[] = '<span style="display:block;font-weight:bold;padding:0;margin:0;">File(s) below seems to be incorrect</span>';
                    $first = false;
                }
                $s = stripos( $csvitem, '.');                        
                if ( $s > 0) {
                    $new_csvitem = substr($csvitem, 0, $s) . '.csv';
                }
                else {
                    $new_csvitem = $csvitem . '.csv';
                }                
                if ( $new_csvitem == '.csv') {$new_csvitem = '*.csv';}   
                $debug_info[] = '<div class="adjustspelling-wrapper"> Did you mean <b><span data-file="' . $csvitem . '" class="adjustspelling">' . $new_csvitem . '</span>? <button class="changefile">Click here to change spelling. The page will update after this change so make sure you have changed all settings before trying this.</button></div>';                    
            }
           
        }
       
        if ( $nr_cols > $nr_rows ) 
        {
            if ( $source_type !== 'guess') {
                $debug_info[] = ' (This could be right but most of cases it is not. If you don\'t get expected output you could try changing type to guess) <button class="useguess">Click here to try and solve the issue. The page will update after this change so make sure you have changed all settings before trying this.</button>.';
            }
        }

        if ( $nr_cols == 1 ) 
        {
            if ( $csv_delimiter != ',') {
                $debug_info[] = 'You\'re probably using incorrect delimiter because only one column is retrieved. <button id="identifydelimiter">Try comma as delimter. The page will update after this change so make sure you have changed all settings before trying this.</button>.';
            }

        }

        if ( isset ( $html_id) )
        {
            if ( mb_strlen( $html_id ) >0 ) 
            {
                for($i=1;$i<10;$i++) 
                {
                    if ( intval(substr($html_id,0,1)) === intval($i) ) {
                        $debug_info[] = 'Your <b>html id</b> would not validate and would not be available for js etc if you\'re not starting with a letter. Begin html id with a letter.';
                        break;
                    }
                }
            }
        }

        if ( mb_strlen( $html_class ) >0 )
        {
            for($i=1;$i<10;$i++) 
            {
                if ( intval(substr($html_class,0,1)) === intval($i) ) {
                    $debug_info[] = 'Your <b>html class</b> would not validate and would not be available for js etc if you\'re not starting with a letter. Begin html id with a letter.';
                    break;
                }
            }        
        }

        if ( mb_strlen( $table_in_cell_wrapperclass ) >0 )
        {
            for($i=1;$i<10;$i++)
            {
                if ( intval(substr($table_in_cell_wrapperclass,0,1)) === intval($i) ) {
                    $debug_info[] = 'Your <b>table in cell wrapper class</b> would not validate and would not be available for js etc if you\'re not starting with a letter. Begin html id with a letter.';
                    break;
                }
            }        
        }
        if ( mb_strlen( $convert_encoding_to ) > 0 && mb_strlen( $convert_encoding_from ) == 0 )
        {
            $debug_info[] = 'If you don\'t get expected result, you should try set current encoding <b>from</b> to the actual encoding of the csv-file. It <i>might</i> work.';
        }

        if ( mb_strlen( $convert_encoding_to ) > 0 && mb_strlen( $convert_encoding_from ) > 0 )
        {
            $debug_info[] = 'Sometimes it\'s easy to think that everything you add will make it better. In some cases removing character encodings might make it better. <button id="removeencodings">Remove encodings. Make sure you have changed all other settings before trying this because the page will update.</button>';
        }
        
        if ( mb_strlen ( $filter_data ) > 0 )
        {
            if ( intval( $filter_col) == 0 )
            {
                $debug_info[] = 'You have set a filter but you have not specified which column to apply the filter on. Do that under Filter-section.';
            }
            else {
                $debug_info[] = 'If you dont get any results <b>' . $filter_data . '</b> may not exist in <b>column ' . $filter_col . '</b> of your table.';
            }
        }

        if ( intval ( $filter_col) > 0 && mb_strlen ( $filter_data ) == 0 )
        {
            $debug_info[] = 'You have specified which filter to apply filter on but you have not set any data in filter data. If your intention is not to have any filter: <button id="removefilter">Remove filter now. Make sure you have changed all settings because this will update page.</button>';
        }


        //Presentation of warnings/errors and possible solutions
        if ( count($debug_info) > 0 ) 
        {
            $html .= '<div class="csvtohtml-p admin debugging">';
            $html .= '<h2>Debugging (Click here if having issues. Known problems and issues could be solved easily).</h2>';
            $html .= '<table><tr><td>';

            foreach( $debug_info as $ditem) {
                $html .= '<p>' . $ditem . '</p>';       
            }

            $html .= '</td></tr></table>';
            $html .= '</div>';
        }
        //End debugging


        $html .= '<div class="csvtohtml-p admin general">';
        $html .= '<h2>General</h2>';
        $html .= '<table>';
    
        $html .= '<tr><td>Number of rows:</td><td>' . $nr_rows . '</td></tr>';
        $html .= '<tr><td>Number of columns:</td><td>' . $nr_cols . '</td></tr>';        
        $html .= '<tr><td>Location of <i>local</i> file(s):</td><td>'. $upload_basedir . '/';
        $html .= '<span id="csvtohtmlsettings-path">' . $path . '</span></td></tr>';
        $html .= '<tr><td>Path (local):</td><td><input type="text" name="frm_path" value="' . $path . '">&nbsp;<button id="pathviewer">...</button></tr>';
        
       
        //Make a list of all directorys under uploads-directory
        $dir_iterator = new DirectoryIterator($upload_basedir);
        $html .= '<tr id="uploadpaths"><td>&nbsp;</td><td>';
        foreach ($dir_iterator as $fileinfo) {
            if ($fileinfo->isDir() && !$fileinfo->isDot()) {
                $html .= '<a class="pathlink" href="#">' . $fileinfo->getFilename().'</a>';
            }
        }
        $html .= '</td></tr>';       

    
        $html .= '<tr><td>File(s) combined to this table:</td><td><input type="text" name="frm_source_files" class="textlong" value="' . $source_files . '">&nbsp;<button id="fileviewer">...</button></td></tr>';
        $html .= '<tr id="fileview"><td>&nbsp;</td><td>';       
        foreach ($dir_iterator as $fileinfo) {
            if (!$fileinfo->isDir()) {
                $html .= '<a data-basename="' . $fileinfo->getBaseName() . '" class="filelink" href="#">' . $fileinfo->getPathName().'</a>';
            }
        }
         $html .= '<td></tr>';
        $html .= '<tr><td colspan="2"><hr></td></tr>';
             
        $html .= '<tr><td>Debugging on:</td><td>
        <b>Note!</b> This is not necessary with Premium version because debug is done automatically from settings page and there is no need for executing this frontend.
        <select style="display:none;" name="frm_debug_mode">';        
        if ( $debug_mode === 'yes') 
        {
            $html .= '<option value="yes" selected>yes</option>';
            $html .= '<option value="no">no</option>';
        }
        else 
        {
            $html .= '<option value="yes">yes</option>';
            $html .= '<option value="no" selected>no</option>';
        }  
        $html .='</select></td></tr>';

        $html .= '<tr><td>Responsive:</td><td><select name="frm_responsive">';
        if ( $responsive === 'yes') 
        {
            $html .= '<option value="yes" selected>yes</option>';
            $html .= '<option value="no">no</option>';
        }
        else 
        {
            $html .= '<option value="yes">yes</option>';
            $html .= '<option value="no" selected>no</option>';
        }       
        $html .='</select></td></tr>';
        $html .= '<tr><td>CSS max width:</td><td><input type="text" name="frm_css_max_width" value="' . $css_max_width . '"</td></tr>';
        $html .= '<tr><td>CSS min devicewidth:</td><td><input type="text" name="frm_css_min_devicewidth" value="' . $css_min_devicewidth . '"</td></tr>';
        $html .= '<tr><td>CSS max devicewidth:</td><td><input type="text" name="frm_css_max_devicewidth" value="' . $css_max_devicewidth . '"</td></tr>';


        $html .= '<tr><td>Add extension automaically:</td><td><select name="frm_add_ext_auto">';
        if ( $add_ext_auto === 'yes') 
        {
            $html .= '<option value="yes" selected>yes</option>';
            $html .= '<option value="no">no</option>';
        }
        else 
        {
            $html .= '<option value="yes">yes</option>';
            $html .= '<option value="no" selected>no</option>';
        }       
        
        $html .= '<tr><td>Type:</td><td>';        
        $html .= '<select name="frm_source_type">';
        if ( $source_type == 'guess') {
            $html .= '<option selected value="guess">guess</option>';
            $html .= '<option value="">visualizer</option>';    
        }
        else {
            $html .= '<option value="guess">guess</option>';
            $html .= '<option selected value="">visualizer</option>';    
        }
        $html .= '</select>';
        
        $html .= '</td></tr>';
        $html .= '<tr><td>End of line detection:</td><td><input type="text" name="frm_eol_detection" value="' . $eol_detection . '"></td></tr>';
       
        $html .= '<tr><td colspan="2"><hr></td></tr>';
       
        $html .= '<tr><td>Delimiter (between values in file):</td><td><input type="text" length="1" name="frm_csv_delimiter" value="'. $csv_delimiter . '"></td></tr>';
        $html .= '<tr><td>Float divider (for numeric usage):</td><td><input type="text" length="1" name="frm_float_divider" value="' . $float_divider . '"</td></tr>';
        $html .= '<tr><td>Fetch last headers:</td><td><select name="frm_fetch_lastheaders">';

        $html .= '<option value="">Not set</option>';

        for($i=1;$i<$nr_cols+1;$i++) 
        {
            $fetch_selected = '';
            if ( intval($fetch_lastheaders)>0 ) {
                if ( $i == $fetch_lastheaders) 
                {
                    $fetch_selected = ' selected';
                }
            }
            $html .= '<option' . $fetch_selected . ' value="' . $i . '">' . $i . '</option>';
        }
        $html .='</select></td></tr>';
        
        $html .= '</table>';
        $html .= '</div>';




        $html .= '<div class="csvtohtml-p admin characterencoding">';
        $html .= '<h2>Chacter encoding</h2>';
        $html .= '<table>';
        $html .= '<tr><td>Convert encoding from:</td><td>';
        $html .= $this->create_select_encoding('frm_convert_encoding_from', $convert_encoding_from);
        $html .= '</td></tr>';
        $html .= '<tr><td>Convert encoding to:</td><td>';
        $html .= $this->create_select_encoding('frm_convert_encoding_to', $convert_encoding_to);
        $html .= '</td></tr>';
        $html .= '</table></div>';        

        if (!isset( $html_id) ) {
            $html_id = '';
        }

        $html .= '<div class="csvtohtml-p admin styling">';
        $html .= '<h2>Styling</h2>';
        $html .= '<table>';
        $html .= '<tr><td>html id:</td><td><input type="text" name="frm_html_id" value="' . $html_id . '">';
        $html .= '<tr><td>html class:</td><td><input type="text" name="frm_html_class" value="' . $html_class . '">';
        $html .= '</table>';
        $html .= '</div>';


        $html .= '<div class="csvtohtml-p admin columns_and_rows">';
        $html .= '<h2>Columns and rows</h2>';
        $html .= '<table>';
        $html .= '<tr><td style="width:100px;padding-right:2em;">Number of rows:</td><td>' . $nr_rows . '</td><td colspan="' . ($nr_cols-2) . '">&nbsp;</td></tr>';
        $html .= '<tr><td style="width:100px;padding-right:2em;">Number of columns:</td><td>' . $nr_cols . '</td><td colspan="' . ($nr_cols-2) . '">&nbsp;</td></tr>';
        $html .= '<tr><td style="width:100px;padding-right:2em;">Include rows:</td><td><input type="text" name="frm_include_rows" value="' . $include_rows . '"></td><td colspan="' . ($nr_cols-2) . '">&nbsp;</td></tr>';

        $column_nr = 1;
        $html .= '<tr><td colspan="2"><table style="margin-left:-2px;">';

        $html .= '<tr>';
        $html .= '<th style="padding-right:4em;">Include/exclude columns</th>';
        for($i=1;$i<$nr_cols+1;$i++) 
        {
            $html .= '<th style="text-align:left;">' . $i . '</th>';
        }

        $html .= '</tr><tr>';
     
        $use_includecols = $csvtohtml_base->adjust_columns( $include_cols ); 
        $use_excludecols = $csvtohtml_base->adjust_columns( $exclude_cols );
        
        $html .= '<td>&nbsp;</td>';

        $check_selected_totals = explode( ',' ,$totals_cols_bottom );
       

        for($i=1;$i<$nr_cols+1;$i++) 
        {
            $selected_include = '';
            $selected_exclude = '';
            if ( in_array( $i-1, $use_includecols) !== false ) 
            {
                $selected_include = ' checked="checked"';
            }
            if ( in_array( $i-1, $use_excludecols) !== false ) 
            {
                $selected_exclude = ' checked="checked"';
            }   
            $selected_ignore = '';
            if ( $selected_exclude == '' && $selected_include == '') {
                $selected_ignore = '  checked="checked"';
            }         
            $selected_total = '';
            if ( in_array ( $i, $check_selected_totals) !== false )
            {
                $selected_total = ' checked="checked"';
            }

            //inclusion/exclusion column clude[col]
            $html .= '<td>
            <div class="check"><input type="radio" name="clude[' . $column_nr . ']" data-num="ignore"' . $selected_ignore . '>None</div>         
            <div class="check"><input type="radio" name="clude[' . $column_nr . ']" data-num="include"'  . $selected_include . '>Include</div>
            <div class="check"><input type="radio" name="clude[' . $column_nr . ']" data-num="exclude"' . $selected_exclude . '>Exclude</div>
            <div class="check"><input type="checkbox" name="totalcl[' . $column_nr . ']" data-num="total"' . $selected_total . '>Total</div>
            </td>';
            $column_nr++;
        }
        $html .= '</td></table></tr>';

        $html .= '<tr><td colspan="2">';
        $html .= '<input type="text" name="frm_include_cols" id="include_shortcode_str" value="' . $include_cols . '">';
        $html .= '<input type="text" name="frm_exclude_cols" id="exclude_shortcode_str" value="' . $exclude_cols . '">';
        $html .= '</td></tr>';
        $html .= '</table>';

       

        $html .= '</div>';

        //Totals in columns
        $html .= '<div class="csvtohtml-p admin totals">';
        $html .= '<h2>Totals (sum / calculation)</h2>';
        $html .= '<table>';        
        $html .= '<input style="display:none;" type="text" name="frm_totals_cols_bottom" value="' . $totals_cols_bottom . '">';
        $html .= '<tr><td>What string/character (maybe a zero?) to show when no calculation is done:</td><td><input type="text" name="frm_totals_cols_bottom_empty" value="' . $totals_cols_bottom_empty . '"</td></tr>';
        $html .= '<tr><td>Set a specific string when added totals (overrides totals_cols_bottom_empty):</td><td><input type="text" name="frm_totals_cols_bottom_title" value="' . $totals_cols_bottom_title . '"</td></tr>';
        $html .= '<tr><td>Which column to set this specific string  :</td><td><input type="text" name="frm_totals_cols_bottom_title_col" value="' . $totals_cols_bottom_title_col . '"</td></tr>';
        $html .= '</table></div>';

        //Sorting
        $html .= '<div class="csvtohtml-p admin sorting">';
        $html .= '<h2>Sorting</h2>';
        $html .= '<table>';
        $column_nr = 1;
        $html .= '<tr><td colspan="2"><table style="margin-left:-2px;">';
        
        $use_sort_cols = $csvtohtml_base->adjust_columns( $sort_cols ); 
        $use_sort_directions = explode(',', $sort_cols_order);

        //Connect columns with sorting directions
        $col_sortdirs = [];        

        //If this occurs, no columns are set
        if ( mb_strlen( $sort_cols ) == 0 )  
        { 
            unset( $use_sort_cols[0] );
        }

        foreach($use_sort_cols as $key => $item) {
            $col_sortdirs[$item] = $use_sort_directions[$key];
        }
        $col_sortdirs_keys = array_keys( $col_sortdirs );

        $html .= '<tr>';
        $html .= '<th style="padding-right:4em;">Sort by column: </th>';
        $iteration = 1;
        for($i=1;$i<$nr_cols+1;$i++) 
        {
            $html .= '<th style="text-align:left;">' . $i . '<br>';
            $html .= '<select name="sortiteration_col[' . $i . ']">';
            $html .= '<option value="-1">Not used</option>';

            for($j=1;$j<$nr_cols+1;$j++)
            { 
                $selected = '';
                $pop = '';

                if ( isset( $col_sortdirs_keys[$j-1]) ) 
                {
                    if ( $col_sortdirs_keys[$j-1] == ($i-1) ) 
                    {
                        $selected = ' selected';
                    }
                    
                }
                $html .= '<option value="' . ($j-1) . '"' . $selected .  '>' . $pop . 'Iteration ' . $j . '</option>';
            }
            $html .= '</select>';
            $html .= '</th>';
        }

        $html .= '</tr><tr>';
        $html .= '<td>&nbsp;</td>';

        for($i=1;$i<$nr_cols+1;$i++) 
        {
            $selected_ignore = '';
            $selected_asc = '';
            $selected_desc = '';

            if (isset($col_sortdirs[$i-1])) 
            {
                if ($col_sortdirs[$i-1] == 'asc') 
                {
                    $selected_asc = ' checked="checked"';
                }
                else if ($col_sortdirs[$i-1] == 'desc') 
                {
                    $selected_desc = ' checked="checked"';
                }
                else {
                    $selected_ignore = ' checked="checked"';
                }
            }
            else {
                $selected_ignore = ' checked="checked"';
            }
  
            //sorting[column] = type of sorting, value = 0=> No sorting, 1=> Sort A-z, 2=> Sort Z-A
            //clude[column] = value 0 => include, 1 => exclude 
            $html .= '<td>
            <div class="check"><input type="radio" name="sorting[' . $column_nr . ']" data-num="nosort"' . $selected_ignore . '>No sorting</div>
            <div class="check"><input type="radio" name="sorting[' . $column_nr . ']" data-num="asc"' . $selected_asc . '>Sort A-Z</div>
            <div class="check"><input type="radio" name="sorting[' . $column_nr . ']" data-num="desc"' . $selected_desc . '>Sort Z-A</div>
            </td>';
            $column_nr++;
        }
        $html .= '</tr>';
        
        $html .= '</table>';
        $html .= '<input type="text" name="frm_sort_cols" id="sort_str" value="' . $sort_cols .  '">';
        $html .= '<input type="text" name="frm_sort_cols_order" id="sort_str_direction" value="' . $sort_cols_order . '">';
        $html .= '</td></tr></table>';

        

        $html .= '</div>';



        $html .= '<div class="csvtohtml-p admin datafilter">';
        $html .= '<h2>Filter</h2>';
        $html .= '<table>';
        $html .= '<tr><td>What data to filer:</td><td><input type="text" name="frm_filter_data" value="' . $filter_data . '"></td></tr>';
        $html .= '<tr><td>Remove characters from filter:</td><td><input type="text" name="frm_filter_removechars" value="' . $filter_removechars . '"</td></tr>';
        
        $filter_arr = [
                        'equals' => 'Equals to ' . $filter_data, 
                        'more' => 'More than ' . $filter_data,
                        'less' => 'Less than ' . $filter_data,
                        'mequal' => 'More or equal to ' . $filter_data,
                        'lequal' => 'Less or equal to ' . $filter_data,
                        'wildcard' => 'Any data within ' . $filter_data . '(wildcard)'
                      ];

        $html .= '<tr><td>Filter operator:</td><td>';
        $html .= '<select name="frm_filter_operator">
        <option value="">not set</option>';

        foreach( $filter_arr as $filter_key => $filter_option) {
            $filter_selected = '';
            if ( $filter_operator == $filter_key) {
                $filter_selected = ' selected';
            }
            $html .= '<option' . $filter_selected . ' value="' . $filter_key . '">' . $filter_option . '</option>';            
        }
        $html .= '</select>
        </td></tr>';
        $html .= '<tr><td>Which column to apply filter on:</td><td><select name="frm_filter_col" id="colfilter">';
        $html .= '<option value="">not set</option>';
        for($i=1;$i<$nr_cols+1;$i++) 
        {
            $filtercol_selected = '';
            if ( $filter_col == $i) {
                $filtercol_selected = ' selected';
            }
            $html .= '<option' . $filtercol_selected . ' value="' . $i . '">' . $i . '</option>';
        }
        $html .='</select></td></tr>';
        $html .= '</table></div>';

        $html .= '<div class="csvtohtml-p admin tableincell">';
        $html .= '<h2>Table in cell(s)</h2>';
        $html .= '<table>';        
        $html .= '<tr><td>Wrapper class:</td><td><input type="text" name="frm_table_in_cell_wrapperclass" value="' . $table_in_cell_wrapperclass . '"</td></tr>';
        $html .= '<tr><td>Header:</td><td><input type="text" name="frm_table_in_cell_header" value="' . $table_in_cell_header . '"</td></tr>';
        $html .= '<tr><td colspan="2"><input type="text" id="table_in_cell_cols" name="frm_table_in_cell_cols" value="' . $table_in_cell_cols . '"</td></tr>';
        $column_nr = 1;
        $html .= '<tr><td colspan="2"><table style="margin-left:-2px;">';

        $html .= '<tr>';
        $html .= '<th style="padding-right:4em;">Include columns</th>';
        for($i=1;$i<$nr_cols+1;$i++) 
        {
            $html .= '<th style="text-align:left;">' . $i . '</th>';
        }

        $html .= '</tr><tr>';
     
        $use_cols = $csvtohtml_base->adjust_columns( $table_in_cell_cols );       
 
        $html .= '<td>&nbsp;</td>';
        for($i=1;$i<$nr_cols+1;$i++) 
        {
            $selected_include = '';
            if ( in_array( $i-1, $use_cols) !== false ) 
            {
                $selected_include = ' checked="checked"';
            }

            

            //inclusion/exclusion column clude[col]
            $html .= '<td>            
            <div class="check"><input type="radio" name="tableincellsclude[' . $column_nr . ']" data-num="ignore"' . $selected_ignore . '>None</div>         
            <div class="check"><input type="radio" name="tableincellsclude[' . $column_nr . ']" data-num="include"'  . $selected_include . '>Include</div>
            </td>';
            $column_nr++;
        }
        $html .= '</td></table></tr>';


        $html .= '</table></div>';

        $html .= '<div class="csvtohtml-p admin pagination">';
        $html .= '<h2>Pagination</h2>';
        $html .= '<table>';        
        $html .= '<tr><td>Pagination active:</td><td><select name="frm_pagination">';
        if ( $pagination === 'yes') 
        {
            $html .= '<option value="yes" selected>yes</option>';
            $html .= '<option value="no">no</option>';
        }
        else 
        {
            $html .= '<option value="yes">yes</option>';
            $html .= '<option value="no" selected>no</option>';
        }       
        $html .='</select></td></tr>';

        $html .= '<tr><td>Show pagination below table:</td><td><select name="frm_pagination_below_table">';
        if ( $pagination_below_table === 'yes') 
        {
            $html .= '<option value="yes" selected>yes</option>';
            $html .= '<option value="no">no</option>';
        }
        else 
        {
            $html .= '<option value="yes">yes</option>';
            $html .= '<option value="no" selected>no</option>';
        }       
        $html .='</select></td></tr>';

        $html .= '<tr><td>Show pagination above table:</td><td><select name="frm_pagination_above_table">';
        if ( $pagination_above_table === 'yes') 
        {
            $html .= '<option value="yes" selected>yes</option>';
            $html .= '<option value="no">no</option>';
        }
        else 
        {
            $html .= '<option value="yes">yes</option>';
            $html .= '<option value="no" selected>no</option>';
        }       
        $html .='</select></td></tr>';        

        if ( mb_strlen( $pagination_start ) == 0)
        {
            $pagination_start = 1;
        }
        $html .= '<tr><td>Row to start pagination with (generally always 1):</td><td><input type="text" name="frm_pagination_start" value="' . $pagination_start . '"</td></tr>';
        $html .= '<tr><td>Text start for pagination. Leave if you do not want to show:</td><td><input type="text" name="frm_pagination_text_start" value="' . $pagination_text_start . '"</td></tr>';
        $html .= '<tr><td>Text Prev (previous) for pagination. Leave empty if you do not want to show:</td><td><input type="text" name="frm_pagination_text_prev" value="' . $pagination_text_prev . '"</td></tr>';
        $html .= '<tr><td>Text Next for pagination. Leave empty if you do not want to show:</td><td><input type="text" name="frm_pagination_text_next" value="' . $pagination_text_next . '"</td></tr>';
        $html .= '<tr><td>Text Last for pagination. Leave empty if you do not want to show:</td><td><input type="text" name="frm_pagination_text_last" value="' . $pagination_text_last . '"</td></tr>';
        $html .= '<tr><td>How many rows you should show at each pagination</td><td><input type="text" name="frm_pagination_rows" value="' . $pagination_rows . '"</td></tr>';
        $html .= '<tr><td>Show links (1,2,3... up to 10 links (10 is default)). Set to 0 if you do not want to show at all:</td><td><input type="text" name="frm_pagination_links_max" value="' . $pagination_links_max . '"</td></tr>';
        $html .= '</table></div>';                                          


        

        $html .= '<div class="csvtohtml-p admin search">';
        $html .= '<h2>Search</h2>';
        $html .= '<table>';        
        $html .= '<tr><td>Search active:</td><td><select name="frm_search_functionality">';
        if ( $search_functionality === 'yes') 
        {
            $html .= '<option value="yes" selected>yes</option>';
            $html .= '<option value="no">no</option>';
        }
        else 
        {
            $html .= '<option value="yes">yes</option>';
            $html .= '<option value="no" selected>no</option>';
        }       
        $html .='</select></td></tr>';

        $html .= '<tr><td>Realtime search (search is done when user is entering searchcriteria):</td><td><select name="frm_search_realtime">';
        if ( $search_realtime === 'yes') 
        {
            $html .= '<option value="yes" selected>yes</option>';
            $html .= '<option value="no">no</option>';
        }
        else 
        {
            $html .= '<option value="yes">yes</option>';
            $html .= '<option value="no" selected>no</option>';
        }       
        $html .='</select></td></tr>';

        $html .= '<tr><td>Hide table when page loads first time (no values are shown until a search is done):</td><td><select name="frm_hidetable_load">';
        if ( $hidetable_load === 'yes') 
        {
            $html .= '<option value="yes" selected>yes</option>';
            $html .= '<option value="no">no</option>';
        }
        else 
        {
            $html .= '<option value="yes">yes</option>';
            $html .= '<option value="no" selected>no</option>';
        }       
        $html .='</select></td></tr>';

        $html .= '<tr><td>Hide table when user clicks reset-button (button is created when search is active):</td><td><select name="frm_hidetable_reset">';
        if ( $hidetable_reset === 'yes') 
        {
            $html .= '<option value="yes" selected>yes</option>';
            $html .= '<option value="no">no</option>';
        }
        else 
        {
            $html .= '<option value="yes">yes</option>';
            $html .= '<option value="no" selected>no</option>';
        }       
        $html .='</select></td></tr>';        

        $html .= '<tr><td>Search button text:</td><td><input type="text" name="frm_searchbutton_text" value="' . $searchbutton_text . '"</td></tr>';
        $html .= '<tr><td>Reset button text:</td><td><input type="text" name="frm_resetbutton_text" value="' . $resetbutton_text . '"</td></tr>';
        $html .= '<tr><td>Placeholder-text for search input field</td><td><input type="text" name="frm_searchinput_placeholder" value="' . $searchinput_placeholder . '"</td></tr>';
        $html .= '<tr><td>What message to show when searchresult is not found (if set to no, don\'t show anything):</td><td><input type="text" name="frm_notfound_message" value="' . $notfound_message . '"</td></tr>';
        $html .= '<tr><td>How many characters at least user must type in before search is valid:</td><td><input type="text" name="frm_search_requiredchars" value="' . $search_requiredchars . '"</td></tr>';
        $html .= '<tr><td>What message to show (tell user there are a required number of chars when doing a search)</td><td><input type="text" name="frm_search_requiredchars_message" value="' . $search_requiredchars_message . '"</td></tr>';

        $html .= '<tr><td>Convert links to html-links (<a>), images to <img> etc:</td><td><select name="frm_htmltags_autoconvert">';
        if ( $htmltags_autoconvert === 'yes') 
        {
            $html .= '<option value="yes" selected>yes</option>';
            $html .= '<option value="no">no</option>';
        }
        else 
        {
            $html .= '<option value="yes">yes</option>';
            $html .= '<option value="no" selected>no</option>';
        }       
        $html .='</select></td></tr>';     

        $html .= '<tr><td>If ordinary links, open them up in a new window (target="_blank"):</td><td><select name="frm_htmltags_autoconvert_newwindow">';
        if ( $htmltags_autoconvert_newwindow === 'yes') 
        {
            $html .= '<option value="yes" selected>yes</option>';
            $html .= '<option value="no">no</option>';
        }
        else 
        {
            $html .= '<option value="yes">yes</option>';
            $html .= '<option value="no" selected>no</option>';
        }       
        $html .='</select></td></tr>';     
        
        $html .= '<tr><td>Set alt text based on a specific columns value (Or same text for all images if you just set some text here instead of a number):</td><td><input type="text" name="frm_htmltags_autoconvert_imagealt" value="' . $htmltags_autoconvert_imagealt . '"</td></tr>';
        

        $html .= '</table></div>';                                          



                  
        

        $html .= '<div>';
        
        echo $html;
        return;
        
    }




    /**
     *  startpage()
     * 
     *  This function shows startup page
     * 
     *  @param N/A
     *  @return N/A
     *                 
     */    
    public function startpage() 
    {
      $html = '<div class="wrap">';
      $html .= '<h1>CSV to html Premium</h1>';
      $html .= '<h2>This plugin uses <strong>CSV to html</strong> plugin as base.</h2>';
      $html .= '<p><b>The CSV to HTML plugin</b> is used for converting any file from uploads-folder or from an external source.</p><p>The plugin fetches data from file(s) directly so there are no need for uploading etc. Debugging is easy by adding a simple attribute. Adding searchfield is easy adding a simple attribute etc.</p>';
      $html .= '<p>It\'s a plugin that has been rated highly for it\'s ease of use but the main disadvantage with the plugin is that you need to keep track of every settings manually with a shortcode.</p>';

      $html .= '<h2>CSV to html Premium (think of it as an extension to the base CSV to html plugin)</h2>';
      $html .= '<ul style="list-style-type:square;margin:0 0 1em 2em;padding:0;">';
      $html .= '<li>Better oveview of current settings</li>';
      $html .= '<li>No need of manually entering values in shortcode(s)</li>';
      $html .= '<li>Settings in a metabox directly under the main content of a page or post</li>';
      $html .= '<li>Switch between settings of independent number of shortcodes of a page/post etc</li>';
      $html .= '<li>Automatically debugging (New section shows when needed) with hints/tips to solve issue(s)</li>';
      $html .= '<li>Lifetime updates and support*</li>';
      $html .= '<li>Always up to date with the CSV to HTML plugin.</li>';
      $html .= '</ul>';
      $html .= '<p style="font-size:10px;font-style:italic;">* If people ignore paying for the plugins development there are a big chance that the plugin will have to "die" and therefore lifetime updates and support will not be available no more.</p>';

      $html .= '<p><b>All main functionaliy is grabbed from the CSV to HTML plugin (so this plugin needs to be installed and activated for the premium plugin to work)</b> but extras as settings and such are developed as an extra service for you. This plugin is compatible with Gutenburg/Wordpress Classic block editor.</p>';
      
      $html .= '<p>You could download this plugin for free (and test it as long as you want) but if you want to use this premium plugin (if you are satisfied), please pay 10EUR to paypal <b>info@paypal.se</b> and enter <b>cth-pr</b> as reference. This would make it possible for futher development of this plugin.</p>';
      $html .= '<p style="margin-top:2em;">If you need any help please don\'t hesitate to contact me, Gustav Wiberg at Wibergs Web. (<a href="mailto:info@wibergsweb.se">info@wibergsweb.se</a>).';
      $html .= '</div>';
      echo $html;
    }


    
    
    
   
    
}
        
$csvtohtmlwPremium = new csvtohtmlwpPremium();
}