


jQuery(function ($) {  

  //Wordpress Classic Editor ("Gutenburg")
  if ( wp.data) {

    var editPost = wp.data.select( 'core/edit-post' ),
      lastIsSaving = false;

    wp.data.subscribe( function() {
        var isSaving = editPost.isSavingMetaBoxes();
        if ( isSaving !== lastIsSaving && !isSaving ) {

          // Assume saving has finished
          lastIsSaving = isSaving;

          let selected_index = $('input[name="frm_current_shortcode"]').find(':selected').val();
          $('#current_shortcodeid').html(selected_index);
          let selected_value = $('#scodes' + selected_index).html();
          $('#new_shortcode').html( selected_value );     

          $("div.csvtohtml-p.admin h2").off( "click");
          
          //Send shortcode-string to server and get attributes to set in form dynamically
          //for chosen shortcode. It's important so correct replacement can be done
          var current_url = my_ajax_object.ajax_url;  
          $.ajax({
            url: current_url,
            method: 'GET',         
            dataType: 'html',
            data:{
                action: 'getform',
                shortcode: selected_value,
                current_scid: selected_index        
            }
          })
          .done(function( response ) {      
            $('#dynamic_form').html( response );
            $("div.csvtohtml-p.admin h2").on( "click", function() {
              $(this).parent().find('table').toggle();
            });

            
          })
          .fail(function(textStatus) {
              console.log('failed getform');
              console.log(textStatus);
          });
              
          }

        lastIsSaving = isSaving;
    } );

}


  var default_values;

  var current_url = my_ajax_object.ajax_url;  
  $.ajax({
    url: current_url,
    method: 'GET',         
    dataType: 'json',
    data:{
        action: 'getdefaults'        
    }
  })
  .done(function( response ) {      
    default_values = response;    
  })
  .fail(function(textStatus) {
      console.log('failed getdefaults');
      console.log(textStatus);
  });


  function  check_length( input_type , element_name ) {
    var tp = 'input';
    if (input_type=='select') {
      tp = 'select';
    }
    var element_nofrm = element_name.substr(4); //Remove four first chars (frm_)

    //Value exists, return value
    let el_val = $('' + tp + '[name="' + element_name  + '"]').val();

    //Is value for element same as default?
    //Then skip it
    if (default_values[element_nofrm] != 'undefined') {

      if (default_values[element_nofrm] == el_val) {
        return '';
      }
      
    }


    if (  el_val.length > 0 ) {
      return element_nofrm + '="' + el_val + '" ';
    }

    //return empty string
    return '';
  }

  function generate_shortcode() {
    var sc_arr = [];

    sc_arr.push('[csvtohtml_create ');
    sc_arr.push( check_length('select','frm_debug_mode') );

    //Responsive
    sc_arr.push( check_length('select','frm_responsive') );
    sc_arr.push( check_length('input','frm_css_max_width') );
    sc_arr.push( check_length('input','frm_css_min_devicewidth') );
    sc_arr.push( check_length('input','frm_css_max_devicewidth') );

    //Html styling
    sc_arr.push( check_length('input','frm_html_id') );
    sc_arr.push( check_length('input','frm_html_class') );

    //General files/paths/format
    sc_arr.push( check_length('input','frm_path') );
    sc_arr.push( check_length('select','frm_source_type') );
    sc_arr.push( check_length('input','frm_source_files') );
    sc_arr.push( check_length('input','frm_eol_detection') );
    sc_arr.push( check_length('input','frm_csv_delimiter') );
    sc_arr.push( check_length('input','frm_float_divider') );
    sc_arr.push( check_length('select','frm_fetch_lastheaders') );
    sc_arr.push( check_length('select','frm_add_ext_auto') );
    
    


     
    //Encoding
    sc_arr.push( check_length('select','frm_convert_encoding_from') );
    sc_arr.push( check_length('select','frm_convert_encoding_to') );
    
    
     

    //Sorting
    sc_arr.push( check_length('input','frm_sort_cols') );
    sc_arr.push( check_length('input','frm_sort_cols_order') );



    //Rows and columns
    sc_arr.push( check_length('input','frm_include_rows') );
    sc_arr.push( check_length('input','frm_include_cols') );
    sc_arr.push( check_length('input','frm_exclude_cols') );



    //Filter
    sc_arr.push( check_length('input','frm_filter_data') );
    sc_arr.push( check_length('input','frm_filter_removechars') );
    sc_arr.push( check_length('select','frm_filter_operator') );
    sc_arr.push( check_length('select','frm_filter_col') );

    //Table in columns
    sc_arr.push( check_length('input','frm_table_in_cell_wrapperclass') );
    sc_arr.push( check_length('input','frm_table_in_cell_header') );
    sc_arr.push( check_length('input','frm_table_in_cell_cols') );

    //Pagination
    sc_arr.push( check_length('select','frm_pagination') );
    sc_arr.push( check_length('select','frm_pagination_below_table') );
    sc_arr.push( check_length('select','frm_pagination_above_table') );
    sc_arr.push( check_length('input','frm_pagination_start') );
    sc_arr.push( check_length('input','frm_pagination_text_start') );
    sc_arr.push( check_length('input','frm_pagination_text_prev') );
    sc_arr.push( check_length('input','frm_pagination_text_next') );
    sc_arr.push( check_length('input','frm_pagination_text_last') );
    sc_arr.push( check_length('input','frm_pagination_rows') );        
    sc_arr.push( check_length('input','frm_pagination_links_max') );
    
    //Search
    sc_arr.push( check_length('select','frm_search_functionality') );
    sc_arr.push( check_length('select','frm_hidetable_load') );
    sc_arr.push( check_length('select','frm_hidetable_reset') );
    sc_arr.push( check_length('select','frm_search_realtime') );
    sc_arr.push( check_length('input','frm_searchbutton_text') );
    sc_arr.push( check_length('input','frm_resetbutton_text') );
    sc_arr.push( check_length('input','frm_searchinput_placeholder') );
    sc_arr.push( check_length('input','frm_notfound_message') );
    sc_arr.push( check_length('input','frm_search_requiredchars') );
    sc_arr.push( check_length('input','frm_search_requiredchars_message') );    
    sc_arr.push( check_length('select','frm_htmltags_autoconvert') );        
    sc_arr.push( check_length('select','frm_htmltags_autoconvert_newwindow') );
    sc_arr.push( check_length('input','frm_htmltags_autoconvert_imagealt') );    

    //Totals
    sc_arr.push( check_length('input','frm_totals_cols_bottom') );
    sc_arr.push( check_length('input','frm_totals_cols_bottom_empty') );
    sc_arr.push( check_length('input','frm_totals_cols_bottom_title') );
    sc_arr.push( check_length('input','frm_totals_cols_bottom_title_col') );

    sc_arr.push(']');
    
    $('#new_shortcode').html( sc_arr.join("") );


    //Replace current shortcode with new and put new content into content-editor

    
    let old_content = '';
    if ($('textarea#content').length >0) {
      old_content = $('textarea#content').html();
    }
    else {
      //"Gutenburg" style (>=WP 5.8)
      old_content = wp.data.select( 'core/editor' ).getCurrentPost().content; 
      if ( wp.data.select( 'core/editor' ).getEditedPostContent() ) {
        old_content =  wp.data.select( 'core/editor' ).getEditedPostContent();
      } 
    }

    //
    
    let current_id = $('#current_shortcodeid').html();
    let old_shortcode = $('#scodes' + current_id).html();
    let new_shortcode = $('#new_shortcode').html();
    let new_content = '';

    if (old_content.length>0) {
      //Is there any shortcode here?
      if (old_content.indexOf('[csvtohtml_create')>-1) {
        //Yes, replace it
        new_content = old_content.replace( old_shortcode, new_shortcode );
      }
      else {
        //No shortcode but there are some content. Put shortcode at the end of the content
        new_content = old_content + '' + new_shortcode;
      }

    }
    else 
    {
      //No content exist, just replace whole content with new shortcode
      new_content = new_shortcode;
    }
   
    $('#scodes' + current_id).html($('#new_shortcode').html()); //Important if replacing more than once (syncronize)
  
    if ($('textarea#content').length >0) {
      $('textarea#content').html( new_content );
    }
    else {
      //"Gutenburg" style (>=WP 5.8)
      wp.data.dispatch( 'core/block-editor' ).resetBlocks( wp.blocks.parse( new_content ) );
    }

  }


  //Create short dynamically when user types / changes anything
  $('body').on('keyup', 'input', function() {
    generate_shortcode();
  });

  $('body').on('click', '#pathviewer', function(e) {
    e.preventDefault();
    $('#uploadpaths').toggle();
  });

  $('body').on('click', '#fileviewer', function(e) {
    e.preventDefault();
    $('#fileview').toggle();
  });  

  $('body').on('click', 'a.filelink', function(e) {
    e.preventDefault();
    let clicked_file = $(this).data('basename');
    let current_val = $('input[name="frm_source_files"]').val();
    $('input[name="frm_source_files"]').val( current_val + ';' + clicked_file ) ;
    generate_shortcode();
  });

  //Debugging events
  $('body').on('click', '.useguess', function(e) {
    e.preventDefault();         
    $('select[name="frm_source_type"]').val('guess');    
    generate_shortcode();
    if ( jQuery('#publish').length>0) {
      jQuery('#publish').click(); //Simulate update-button
    }
    else {
      //"Gutenberg block editor"
      $('button.editor-post-publish-button').click();
    }
  });

  $('body').on('click', '#identifydelimiter', function(e) {
    e.preventDefault();         
    $('input[name="frm_csv_delimiter"]').val( ',' );
    generate_shortcode();
    if ( jQuery('#publish').length>0) {
      jQuery('#publish').click(); //Simulate update-button
    }
    else {
      //"Gutenberg block editor"
      $('button.editor-post-publish-button').click();
    }
  });

  $('body').on('click', '#removeencodings', function(e) {
    e.preventDefault();         
    $('select[name="frm_convert_encoding_from"]').val( '' );
    $('select[name="frm_convert_encoding_to"]').val( '' );
    generate_shortcode();
    if ( jQuery('#publish').length>0) {
      jQuery('#publish').click(); //Simulate update-button
    }
    else {
      //"Gutenberg block editor"
      $('button.editor-post-publish-button').click();
    }
  });

  $('body').on('click', '#removefilter', function(e) {
    e.preventDefault();         
    $('input[name="frm_filter_data"]').val( '' );
    $('select[name="frm_filter_col"]')[0].selectedIndex = 0;    
    generate_shortcode();
    if ( jQuery('#publish').length>0) {
      jQuery('#publish').click(); //Simulate update-button
    }
    else {
      //"Gutenberg block editor"
      $('button.editor-post-publish-button').click();
    }
  });
  //End debugging events


  


  //This is used when user might have mispelled a file
  $('body').on('click', '.changefile', function(e) {
    e.preventDefault();         
    let old_file = $('.adjustspelling').data('file');
    let new_file = $(this).parent().find('.adjustspelling').html();

    //Replace file and put replacement in source_files
    let current_sourcefiles = $('input[name="frm_source_files"]').val();
    let cs = current_sourcefiles.replace( old_file, new_file );
    $('input[name="frm_source_files"]').val(cs);
    generate_shortcode();
    if ( jQuery('#publish').length>0) {
      jQuery('#publish').click(); //Simulate update-button
    }
    else {
      //"Gutenberg block editor"
      $('button.editor-post-publish-button').click();
    }
  });




  $('body').on('click', 'a.pathlink', function(e) {
    e.preventDefault();
    let clickedon_folder = $(this).html();

    //Set input folderpath and also replace/add to baseupload folder for csv-files
    $('input[name="frm_path"]').val( clickedon_folder );
    $('#csvtohtmlsettings-path').html( clickedon_folder );    
    generate_shortcode();
  });

  $('body').on('change', 'select', function() {
    if ($(this).hasClass('choice_sc')) { 

      //select to select shortcodes
      let selected_index = $(this).find(':selected').val();
      $('#current_shortcodeid').html(selected_index);
      let selected_value = $('#scodes' + selected_index).html();
      $('#new_shortcode').html( selected_value );     

      $("div.csvtohtml-p.admin h2").off( "click");
      
      //Send shortcode-string to server and get attributes to set in form dynamically
      //for chosen shortcode. It's important so correct replacement can be done
      var current_url = my_ajax_object.ajax_url;  
      $.ajax({
        url: current_url,
        method: 'GET',         
        dataType: 'html',
        data:{
            action: 'getform',
            shortcode: selected_value,
            current_scid: selected_index        
        }
      })
      .done(function( response ) {      
        $('#dynamic_form').html( response );
        $("div.csvtohtml-p.admin h2").on( "click", function() {
          $(this).parent().find('table').toggle();
        });

        
      })
      .fail(function(textStatus) {
          console.log('failed getform');
          console.log(textStatus);
      });
    
      
    }
    else {
      generate_shortcode();
    }
    
  });

  //Total (bottom of table)
  $('body').on('click', 'div input[name^="totalcl"]', function() {

    let total_cols_bottom = '';
    $('div input[name^="totalcl"]').each(function( index ) {
      if ( $(this).is(':checked')) {
        total_cols_bottom += '' + (index+1) + ',';
      }
      
     
    });

    //Remove last char
    total_cols_bottom = total_cols_bottom.slice(0, -1); 
    $('input[name="frm_totals_cols_bottom"]').val(total_cols_bottom);
    generate_shortcode();
    
  });

  $('body').on('click', 'div input[name^="sorting"]', function() {
    doSort();
  });

  $('body').on('change', 'div select[name^="sortiteration_col"]', function() {
    doSort();
  });

  function doSort() {
      var str_sort = '';
      var str_sort_direction = '';
      var row = 1;

      var icol = [];
      $('div select[name^="sortiteration_col"]').each(function( index ) {

          var this_name = $(this).attr('name'),
          col_number  = this_name.split('[')[1].split(']')[0];
          var iteration = $('div select[name="sortiteration_col[' + col_number + ']"');

          var iteration_nr = null;
          if (iteration.length>0) {
            iteration_nr = parseInt(iteration.val());            
          }           
          icol.push( iteration_nr );
         
      });
           
     

      //Rearrange iteration/sortingorder values for column array
      var iterationorder_col = [];
      var sortorder_col = [];
      var use_col;

      for (var i = 0; i < icol.length; i++) {
        use_col = icol.indexOf(i) + 1;
        
        //Iteration order (in which order column(s) are sorted)
        iterationorder_col[i] = use_col;  //+1 to tell which column

        //Sortorder (asc,desc,ignore)
        var this_obj = $('div input[name="sorting[' + use_col + ']"');        
        var use_data = '';
        this_obj.each(function( index ) {
          if ($(this).is(':checked')) {
            use_data = $(this).data('num');
            return false;
          }
        });
                        
        sortorder_col.push(use_data);
      
      }

      //Generate final attribute inclusion of sorting columns      
      //Skip when nosort or col is set to zero
      for(i=0;i<iterationorder_col.length;i++) {
        if ( sortorder_col[i] !== 'nosort' && iterationorder_col[i]>0) {
          str_sort += '' + iterationorder_col[i] + ',';
          str_sort_direction += sortorder_col[i] + ',';
        }
      };

      //Remove last char
      str_sort = str_sort.slice(0, -1); 
      str_sort_direction = str_sort_direction.slice(0, -1);   
      
      $('#sort_str').val(str_sort);
      $('#sort_str_direction').val(str_sort_direction);

      generate_shortcode();

  };

  //Change location of (local) files when modifiying path
  $('body').on('keyup', 'div input[name="frm_path"]', function(){
    $('#csvtohtmlsettings-path').html($(this).val());
  });

  //Inclusion of cell table in cells functionality
  $('body').on('click', 'div input[name^="tableincellsclude"]', function(){
    var str_include = '';
    var str_exclude = '';

    var clude_arr = $('div input[name^="tableincellsclude"]');
    if (clude_arr.length > 0) {
      
      str_include = '';

      //Go through all include/exclude radio buttons
      clude_arr.each(function( index ) {
        
        if ($(this).is(':checked')) {   
          var current_data = $(this).data('num');

          //Get column of checked radiobutton...                        
          var this_name = $(this).attr('name'),
          col_number  = this_name.split('[')[1].split(']')[0];
           
          //Get values from data-attr for clude[col]
          if (current_data == 'ignore') {
            //Remove this columns values from both include and exclude
            str_include = str_include.replace( col_number + ',', '');
          }
          if (current_data == 'include') {
            str_include += col_number + ',';
          }
        
          }
      });

      //Remove last char
      str_include = str_include.slice(0, -1); 
      str_exclude = str_exclude.slice(0, -1);        
      
      if (str_include == 'include_cols="') {
        str_include = '';
      }

     $('#table_in_cell_cols').val(str_include);

      generate_shortcode();
    }

  });

  


  //Include/Excklusion of columns
  $('body').on('click', 'div input[name^="clude"]', function(){
     
      var str_include = '';
      var str_exclude = '';

      var clude_arr = $('div input[name^="clude"]');
      if (clude_arr.length > 0) {
        
        str_include = '';
        str_exclude = '';
        var nr_cols = 0;

        //Go through all include/exclude radio buttons
        clude_arr.each(function( index ) {
          
          if ($(this).is(':checked')) {   
            var current_data = $(this).data('num');

            //Get column of checked radiobutton...                        
            var this_name = $(this).attr('name'),
            col_number  = this_name.split('[')[1].split(']')[0];
             
            //Get values from data-attr for clude[col]
            if (current_data == 'ignore') {
              //Remove this columns values from both include and exclude
              str_include = str_include.replace( col_number + ',', '');
              str_exclude = str_exclude.replace( col_number + ',', '');
            }
            if (current_data == 'include') {
              str_include += col_number + ',';
            }
            if (current_data == 'exclude') {
              str_exclude += col_number + ',';
            } 
          
            }

            nr_cols++;
        });

        //Remove last char
        str_include = str_include.slice(0, -1); 
        str_exclude = str_exclude.slice(0, -1);        
        
        if (str_include == 'include_cols="') {
          str_include = '';
        }
        if (str_exclude == 'exclude_cols="') {
          str_exclude = '';
        }

        var incl_sc = $('#include_shortcode_str').val(str_include);
        var excl_sc = $('#exclude_shortcode_str').val(str_exclude);       

        //If number of exclusion is set to number of columns
        if (excl_sc.val().length == nr_cols) {
          alert('If you exclude everything - nothing is shown!');
        }

      }

    generate_shortcode();
      
  });


  $("div.csvtohtml-p.admin h2").on( "click", function() {
    $(this).parent().find('table').toggle();
  });


});